/*

    Meta-Environment - An environment for language prototyping.
    Copyright (C) 2000  Stichting Mathematisch Centrum, Amsterdam, The Netherlands. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA

    $Id: AsFixUtilitiesTest.java,v 1.1 2000/04/15 15:18:45 mdejonge Exp $
*/
package nl.cwi.gipe.stred.test;
import nl.cwi.gipe.stred.*;
import junit.framework.*;
import java.io.*;
import toolbus.aterm.*;

public class AsFixUtilitiesTest extends TestCase {

	public ATerm variable;
	public Sort sort;
	
	public AsFixUtilitiesTest(String str) throws ParseError {
		super(str);
		setUp();
	}

	public void setUp() throws ParseError {
		variable = ATerm.the_world.makeSimple("var(\"Bool0\",sort(\"PICO-BOOL\")){[length,length(5)]}");
		sort = new Sort((ATermAppl) ATerm.the_world.makeSimple("sort(\"PICO-BOOL\")"));
  }
	
	public void testTypeOf() {
		assertEquals(AsFixUtilities.typeOf(variable),sort);
	}
	
	public static Test suite() throws ParseError {
    TestSuite suite= new TestSuite();
    suite.addTest(new AsFixUtilitiesTest("testTypeOf"));
		return suite;
	}
	public static void main(String args[]) {
		junit.textui.TestRunner.run(AsFixUtilitiesTest.class);
	}
}
